<template>
  <section>
    <ul>
      <li v-for="(todoItem, index) in this.storedTodoItems" class="shadow" v-bind:key="todoItem.item">
        <i class="checkBtn fas fa-check" v-bind:class="{checkBtnCompleted: todoItem.completed}" v-on:click="toggleComplete({todoItem, index})"></i>
        <span v-bind:class="{textCompleted: todoItem.completed}">{{ todoItem.item }}</span>
        <span class="removeBtn" v-on:click="removeTodo({todoItem, index})">
          <i class="removeBtn fas fa-trash-alt"></i>
        </span>
      </li>
    </ul>
  </section>
</template>

<script>
import { mapGetters, mapMutations } from 'vuex'

export default {
  data: function() {
    return {
      todoItems: []
    }
  },
  methods: {
      ...mapMutations({ 
        removeTodo : 'removeOneItem',
        toggleComplete : 'toggleOneItem',
      }),
    // removeTodo: function(todoItem, index) {
      // this.$emit('removeItem', todoItem, index);
      // const obj = {
      //   todoItem,
      //   index
      // }
      // helper함수들은 인자를 선언하지 않아도 호출하는 단에서 인자가 있으면 암묵적으로 인자를 그대로 들고와서 넘겨준다.
      // 단 인자는 하나여만 하기 때문에 템플릿에서 인자를 객체로 묶어 줘야 한다.
    
      // this.$store.commit('removeOneItem', {todoItem, index});
      // this.todoItems.splice(index, 1);
      // localStorage.removeItem(todoItem);
    // },
   // toggleComplete: function(todoItem, index) {
      // 방법1
      // todoItem.completed = !todoItem.completed;
      // localStorage.removeItem(todoItem.item);
      // localStorage.setItem(todoItem.item, JSON.stringify(todoItem));
      // 방법2
      // this.$emit('toggleItem', todoItem, index);
      // 방법3
     // this.$store.commit('toggleOneItem', {todoItem, index});
  //},
  // created: function() {
  //   if (localStorage.length > 0) {
  //     for (var i = 0; i < localStorage.length; i++) {
  //       if (localStorage.key(i) !== 'loglevel:webpack-dev-server') {
  //         this.todoItems.push(JSON.parse(localStorage.getItem(localStorage.key(i))));
  //       }
  //     }
    },
    computed:{
      // todoItems(){
      //   return this.$store.getters.storedtodoItems;
      // }
      ...mapGetters(['storedTodoItems'])
    }
   
}
</script>

<style scoped>
ul {
  list-style-type: none;
  padding-left: 0px;
  margin-top: 0;
  text-align: left;
}
li {
  display: flex;
  min-height: 50px;
  height: 50px;
  line-height: 50px;
  margin: 0.5rem 0;
  padding: 0 0.9rem;
  background: white;
  border-radius: 5px;
}
.checkBtn {
  line-height: 45px;
  color: #62acde;
  margin-right: 5px;
}
.checkBtnCompleted {
  color: #b3adad;
}
.textCompleted {
  text-decoration: line-through;
  color: #b3adad;
}
.removeBtn {
  margin-left: auto;
  color: #de4343;
}
</style>
